#import datetime
import re
import math
from datetime import datetime

##Aktuelle Stunde besstimmen - DasWetterCom 
now = datetime.now()
current_hour = str(int(now.strftime("%H")))

print ("aktuelle Stunde: "+current_hour  )
def clear_display(epd):
    global image, draw
    epd.Clear(0xFF)
    image = Image.new('1', (epd.height, epd.width), 255)
    draw = ImageDraw.Draw(image)
    epd.display(epd.getbuffer(image))


def round_to_one_digit(number):
    """Rounds a two-digit decimal number to one decimal place.

    Args:
        number (str): The two-digit decimal number as a string (e.g., "1.23").

    Returns:
        float: The rounded one-digit decimal number.
    """

    # Check if input is already one-digit or less
    try:
        if abs(float(number)) <= 1:
            return float(number)
    except ValueError:
        # Handle non-numeric input (e.g., "abc")
        raise ValueError(f"Invalid input: '{number}'")

    # Round to one decimal place using round()
    rounded_number = round(float(number), 1)

    # Check if rounding introduced a leading zero (e.g., 0.1 -> 0.10)
    if rounded_number == 0.0:
        return 0.0

    # Remove the trailing zero (e.g., 1.20 -> 1.2)
    return float(f"{rounded_number:.1f}")

def add_leading_space(number):
  """Adds a leading space before one-digit numbers (e.g., 1 becomes ' 1', 1.2 becomes ' 1.2').

  Args:
      number (str or float): The number to format (can be a string or float).

  Returns:
      str: The formatted number with a leading space for one-digit integers before the decimal point.

  Raises:
      ValueError: If the input cannot be converted to a string.
  """

  try:
    # Convert to string if necessary
    number_str = str(number)
  except ValueError:
    raise ValueError(f"Invalid input: '{number}'")

  # Check if the integer part is one character and not just a sign
  if len(number_str.split('.')[0]) == 1 and not number_str.startswith('-'):
    # Add leading space for one-digit integers
    formatted_number = ' ' + number_str
  else:
    # No leading space for non-one-digit integers or with leading sign
    formatted_number = number_str

  return formatted_number




def get_time_from_timestamp(timestamp):
    """Extracts and displays the time in 24-hour format (HH:mm) from a timestamp.

    Args:
        timestamp (datetime object or timestamp string): The timestamp to extract the time from.

    Returns:
        str: The time in 24-hour format (HH:mm).
    """
    #wenn zu lang fdie letzten 3 Stellen abschneiden
    if len(timestamp)==13:
        timestamp=int(timestamp[:-3])

    try:
        # Convert to datetime object if necessary
        if not isinstance(timestamp, datetime):
            timestamp = datetime.fromtimestamp(timestamp)

        # Extract and format time
        time_str = timestamp.strftime('%H:%M')
        return time_str

    except (TypeError, ValueError):
        raise ValueError(f"Invalid timestamp: '{timestamp}'")

def replace_decimal_with_comma(string):
    # Replace the decimal point with a comma
    new_string = string.replace(".", ",")
    return new_string


def replace_comma_with_decimal(string):
    # Replace the decimal point with a comma
    new_string = string.replace(",", ".")
    return new_string

def wind_conversion(wind_speed_ms):
    """Converts wind speed from m/s to km/h and Beaufort scale.

    Args:
        wind_speed_ms (float): Wind speed in meters per second (m/s).

    Returns:
        tuple: A tuple containing:
            - wind_speed_kmh (float): Wind speed in kilometers per hour (km/h).
            - beaufort_scale (int): Beaufort scale wind force number.
    """
    wind_speed_ms = float(wind_speed_ms)
    if wind_speed_ms < 0:
        raise ValueError("Wind speed cannot be negative.")

    wind_speed_kmh = round((wind_speed_ms * 3.6),2)
    print(wind_speed_kmh)
    
    # Beaufort scale mapping
    beaufort_scale = 0
    if wind_speed_kmh <= 1.9:
        beaufort_scale = 0
    elif wind_speed_kmh <= 4.9:
        beaufort_scale = 1
    elif wind_speed_kmh <= 7.9:
        beaufort_scale = 2
    elif wind_speed_kmh <= 11.9:
        beaufort_scale = 3
    elif wind_speed_kmh <= 16.9:
        beaufort_scale = 4
    elif wind_speed_kmh <= 21.9:
        beaufort_scale = 5
    elif wind_speed_kmh <= 26.9:
        beaufort_scale = 6
    elif wind_speed_kmh <= 31.9:
        beaufort_scale = 7
    elif wind_speed_kmh <= 37.9:
        beaufort_scale = 8
    elif wind_speed_kmh <= 43.9:
        beaufort_scale = 9
    elif wind_speed_kmh <= 49.9:
        beaufort_scale = 10
    elif wind_speed_kmh <= 55.9:
        beaufort_scale = 11
    else:
        beaufort_scale = 12

    return wind_speed_kmh, beaufort_scale

def extract_weather_code(url):
    """Extracts the weather code (e.g., '10d') from a weather icon URL.

    Args:
        url (str): The URL of the weather icon image.

    Returns:
        str: The extracted weather code, or an empty string if not found.
    """

    # Regular expression pattern to match the weather code
    pattern = r"/w/(\d{2})([a-z])\.png"  # Updated pattern

    # Match the URL against the pattern
    match = re.search(pattern, url)

    # If a match is found, extract the weather code
    if match:
        weather_code = match.group(1) + match.group(2)  # Combine groups
    else:
        weather_code = ""

    return weather_code

def get_german_weekday_abbr(timestamp):
    """Gets the first two letters of the German weekday from a timestamp.

    Args:
        timestamp (datetime.datetime or int or float): The timestamp to convert.

    Returns:
        str: The first two letters of the German weekday name (e.g., "Mo", "Di", "Mi", etc.).
    """
    #wenn zu lang fdie letzten 3 Stellen abschneiden
    if len(timestamp)==13:
        timestamp=int(timestamp[:-3])
        
    # Convert timestamp to datetime if necessary
    if not isinstance(timestamp, datetime):
        timestamp = datetime.fromtimestamp(timestamp)

    # Get the weekday number (0=Monday, 1=Tuesday, etc.)
    weekday_num = timestamp.weekday()

    # Map weekday number to German weekday abbreviation
    german_weekday_abbreviations = ("Mo", "Di", "Mi", "Do", "Fr", "Sa", "So")
    german_weekday_abbr = german_weekday_abbreviations[weekday_num]

    return german_weekday_abbr

def round_to_integer(temperature):
  """Rounds a number to the nearest integer, removing the decimal part.

  Args:
    temperature: The number or string representation of a number to be rounded.

  Returns:
    The rounded integer.
  """

  if isinstance(temperature, int):
    return temperature  # No rounding needed for integers

  try:
    # Attempt to convert temperature to a float if it's a string
    temperature = float(temperature)
  except ValueError:
    # If conversion fails, return None indicating an invalid input
    return None

  return round(temperature)  # Round the floating-point number


def gira_temp_extract(temperature_string):
  """Extracts and rounds temperatures to integers from a given string.

  Args:
    temperature_string: The string containing temperature values.

  Returns:
    A list of rounded temperatures as integers.
  """

  # Extract temperature values using regular expressions
  temperature_regex = r"(\d+\.?\d*)°C"
  matches = re.findall(temperature_regex, temperature_string)

  # Convert and round temperatures to integers
  rounded_temperatures = [int(round(float(temperature))) for temperature in matches]

  return rounded_temperatures



