#!/usr/bin/python
# -*- coding:utf-8 -*-
#Test
import sys
import os
picdir = 'pic'
libdir = 'lib'
#fontdir='/assets/font'
if os.path.exists(libdir):
    sys.path.append(libdir)

import logging
from lib.waveshare_epd import epd7in5b_V2
import time
import requests
from PIL import Image, ImageDraw, ImageFont, ImageEnhance
import traceback
import anzeigen as az

from functions import clear_display

logging.basicConfig(level=logging.DEBUG)

try:
    logging.info("epd7in5bc_V2 Demo")

    epd = epd7in5b_V2.EPD()
    #epd = epd7in5bc.EPD()
    logging.info("init and Clear")
    epd.init()
    #epd.Clear()
    font36_symbol = ImageFont.truetype(os.path.join(picdir, 'Font.ttc'), 36, encoding="utf-8")
    
    font12 = ImageFont.truetype(os.path.join(picdir, 'Roboto-Medium.ttf'), 12, encoding="utf-8")
    font24 = ImageFont.truetype(os.path.join(picdir, 'Roboto-Medium.ttf'), 24, encoding="utf-8")
    font18 = ImageFont.truetype(os.path.join(picdir, 'Roboto-Medium.ttf'), 18, encoding="utf-8")
    font28 = ImageFont.truetype(os.path.join(picdir, 'Roboto-Medium.ttf'), 28, encoding="utf-8")
    font36 = ImageFont.truetype(os.path.join(picdir, 'Roboto-Medium.ttf'), 36, encoding="utf-8")
    font12_light = ImageFont.truetype(os.path.join(picdir, 'Roboto-Light.ttf'), 12, encoding="utf-8")
    font24_light = ImageFont.truetype(os.path.join(picdir, 'Roboto-Light.ttf'), 24, encoding="utf-8")
    font18_light = ImageFont.truetype(os.path.join(picdir, 'Roboto-Light.ttf'), 18, encoding="utf-8")
    font28_light = ImageFont.truetype(os.path.join(picdir, 'Roboto-Light.ttf'), 28, encoding="utf-8")
    font36_light = ImageFont.truetype(os.path.join(picdir, 'Roboto-Light.ttf'), 36, encoding="utf-8")
    
    roboto_icon = ImageFont.truetype(os.path.join(picdir, 'RobotoMono-Regular.ttf'), 60, encoding="utf-8") 
    #yotu = ImageFont.truetype(os.path.join(picdir, 'yotu.ttf'), 60, encoding="utf-8") 
    #Wetter handgezeichnet
    sketchfont = ImageFont.truetype(os.path.join(picdir, 'SketchIcons.ttf'), 60, encoding="utf-8") 
    sketchfont_small = ImageFont.truetype(os.path.join(picdir, 'SketchIcons.ttf'), 30, encoding="utf-8") 
    sketchfont2 = ImageFont.truetype(os.path.join(picdir, 'PeaxDrawnIcons.ttf'), 60, encoding="utf-8") 
    peaxFont_small = ImageFont.truetype(os.path.join(picdir, 'PeaxDrawnIcons.ttf'), 30, encoding="utf-8") 
    
    #Haussymbol
    sketchfont3 = ImageFont.truetype(os.path.join(picdir, 'heydings_icons.ttf'), 36, encoding="utf-8")         
            
    fontWeatherIcons30 = ImageFont.truetype(os.path.join(picdir, 'meteocons.ttf'), 30)
    fontWeatherIcons40 = ImageFont.truetype(os.path.join(picdir, 'meteocons.ttf'), 40)
    fontWeatherIcons60 = ImageFont.truetype(os.path.join(picdir, 'meteocons.ttf'), 60)
    fontWeatherIcons100 = ImageFont.truetype(os.path.join(picdir, 'meteocons.ttf'), 100)

    #fun
    funfont = ImageFont.truetype(os.path.join(picdir, 'JournalDingbats2.ttf'), 120)


    # Drawing on the Horizontal image
    logging.info("1.Drawing on the Horizontal image...")
    
    #Rand links rechts 20 
    
    # # Drawing on the Vertical image
    logging.info("2.Drawing on the Vertical image...")
    Limage = Image.new('1', (epd.height, epd.width), 255)  # 255: clear the frame
    Limage_Other = Image.new('1', (epd.height, epd.width), 255)  # 255: clear the frame
    draw_Himage = ImageDraw.Draw(Limage)
    draw_Himage_Other = ImageDraw.Draw(Limage_Other)
    #Startpunkt  - letzter Zielpunkt 
    
    #1. Block oben##########################################
    #Symbol oben mitte
    if az.warning_count>0:
        draw_Himage.text((180, 50), az.wettersymbol_zentral_gross, font = fontWeatherIcons60, fill = 0)
    else:
        draw_Himage.text((180, 0), az.wettersymbol_zentral_gross, font = fontWeatherIcons100, fill = 0)
    
    #Haussymbol zeichnen + Haustemperatur 
    koordinaten_block1_x=0
    koordinaten_block1_y=0
    #Solarforecast
    draw_Himage.text((koordinaten_block1_x+70, koordinaten_block1_y+90), "Solarforecast", font = font12, fill = 0)  
    draw_Himage.text((koordinaten_block1_x+70, koordinaten_block1_y+100), "<", font = peaxFont_small, fill = 0)  
    draw_Himage.text((koordinaten_block1_x+100, koordinaten_block1_y+110), az.solar_forecast, font = font24, fill = 0)    
    
   #Batteriestand 0
    koordinaten_batterie_x=koordinaten_block1_x+20
    koordinaten_batterie_y=koordinaten_block1_y+40
    draw_Himage.text((koordinaten_batterie_x-15, koordinaten_batterie_y-5), "0", font = sketchfont, fill = 0)  
    draw_Himage.text((koordinaten_batterie_x+30, koordinaten_batterie_y), az.batterie_soc, font = font36, fill = 0)  
    
    koordinaten_haustemp_x=koordinaten_block1_x+220
    koordinaten_haustemp_y=koordinaten_block1_y+100
    # Symbol Haus 
    draw_Himage.text((koordinaten_haustemp_x, koordinaten_haustemp_y), "H", font = sketchfont3, fill = 0)  
    #Temperatur Haus 
    draw_Himage.text((koordinaten_haustemp_x+35, koordinaten_haustemp_y), az.temperatur_haus, font = font36, fill = 0)  
    # Luftfeuchte
    draw_Himage.text((koordinaten_haustemp_x-100, koordinaten_haustemp_y+50), az.luftfeuchte_haus, font = font28, fill = 0)  
    # Symbol vor Regenwahrscheinlichkeit
    draw_Himage.text((koordinaten_haustemp_x-5, koordinaten_haustemp_y+50), az.symbol_regenwahrscheinlichkeit, font = fontWeatherIcons30, fill = 0)  
    #Regenwahrscheinlichkeit
    draw_Himage.text((koordinaten_haustemp_x+35, koordinaten_haustemp_y+50), az.regen_aktuell, font = font28, fill = 0)  

    #Warnungen zeichnen
    koordinaten_warnung_x=koordinaten_block1_x+100
    koordinaten_warnung_y=koordinaten_block1_y
    draw_Himage_Other.text((koordinaten_warnung_x, koordinaten_warnung_y), az.warnung_symbol, font = sketchfont, fill = 0)  
    draw_Himage_Other.text((koordinaten_warnung_x+45, koordinaten_warnung_y+10), az.warnung, font = font28, fill = 0)
    draw_Himage_Other.text((koordinaten_warnung_x+45, koordinaten_warnung_y+33), az.warnung1, font = font28, fill = 0)
    draw_Himage.line((0,200,480,200),fill = 0, width=2)
   
###### Block 2 ########################################################################################################
    koordinaten_forecast_x=koordinaten_block1_x+40
    koordinaten_forecast_y=koordinaten_block1_y+220
    # 3h
    draw_Himage.text((koordinaten_forecast_x, koordinaten_forecast_y+8), az.vorhersage_3h_zeit, font = font28, fill = 0)  
    draw_Himage.text((koordinaten_forecast_x+80, koordinaten_forecast_y), az.vorhersage_3h_wettersymbol, font = fontWeatherIcons60, fill = 0)  
    draw_Himage.text((koordinaten_forecast_x+150, koordinaten_forecast_y), az.vorhersage_3h_temperatur, font = font36, fill = 0)  
    draw_Himage.text((koordinaten_forecast_x+160, koordinaten_forecast_y+30), az.vorhersage_3h_text, font = font24, fill = 0)  
    
    
    #6h
     
    draw_Himage.text((koordinaten_forecast_x, koordinaten_forecast_y+88), az.vorhersage_6h_zeit, font = font28, fill = 0)  
    draw_Himage.text((koordinaten_forecast_x+80, koordinaten_forecast_y+80), az.vorhersage_6h_wettersymbol, font = fontWeatherIcons60, fill = 0)  
    draw_Himage.text((koordinaten_forecast_x+150, koordinaten_forecast_y+80), az.vorhersage_6h_temperatur, font = font36, fill = 0)  
    draw_Himage.text((koordinaten_forecast_x+160, koordinaten_forecast_y+110), az.vorhersage_6h_text, font = font24, fill = 0)  
    #9h
    
    draw_Himage.text((koordinaten_forecast_x, koordinaten_forecast_y+168), az.vorhersage_9h_zeit, font = font28, fill = 0)  
    draw_Himage.text((koordinaten_forecast_x+80, koordinaten_forecast_y+160), az.vorhersage_9h_wettersymbol, font = fontWeatherIcons60, fill = 0)  
    draw_Himage.text((koordinaten_forecast_x+150, koordinaten_forecast_y+160), az.vorhersage_9h_temperatur, font = font36, fill = 0)  
    draw_Himage.text((koordinaten_forecast_x+160, koordinaten_forecast_y+190), az.vorhersage_9h_text, font = font24, fill = 0)  
    
    draw_Himage.line((0,450,480,450),fill = 0, width=2)    
    
   #### BLOCK 3 ######################################################################################################### 
    #3 Tagesvorschau
    koordinaten_tagesforecast_x=40+koordinaten_block1_x-10
    koordinaten_tagesforecast_y=450+koordinaten_block1_y
    #1. Tag
    draw_Himage.text((koordinaten_tagesforecast_x+30, koordinaten_tagesforecast_y+15), az.vorhersage_tag1_zeit, font = font28, fill = 0,align="center")  
    draw_Himage.text((koordinaten_tagesforecast_x+65, koordinaten_tagesforecast_y+15), az.vorhersage_tag1_wind, font = sketchfont, fill = 0,align="center")  
    draw_Himage.text((koordinaten_tagesforecast_x+15, koordinaten_tagesforecast_y+45), az.vorhersage_tag1_wettersymbol, font = fontWeatherIcons60, fill = 0,align="center")  
    draw_Himage.text((koordinaten_tagesforecast_x, koordinaten_tagesforecast_y+110), az.vorhersage_tag1_temperatur_min, font = font36, fill = 0,align="center")  
    draw_Himage.text((koordinaten_tagesforecast_x, koordinaten_tagesforecast_y+140), az.vorhersage_tag1_temperatur_max, font = font36, fill = 0,align="center")  
    
    
    #2. Tag
    draw_Himage.text((koordinaten_tagesforecast_x+185, koordinaten_tagesforecast_y+15), az.vorhersage_tag2_zeit, font = font28, fill = 0,align="center")  
    draw_Himage.text((koordinaten_tagesforecast_x+220, koordinaten_tagesforecast_y+15), az.vorhersage_tag2_wind, font = sketchfont, fill = 0,align="center")  
    draw_Himage.text((koordinaten_tagesforecast_x+170, koordinaten_tagesforecast_y+45), az.vorhersage_tag2_wettersymbol, font = fontWeatherIcons60, fill = 0,align="center")  
    draw_Himage.text((koordinaten_tagesforecast_x+155, koordinaten_tagesforecast_y+110), az.vorhersage_tag2_temperatur_min, font = font36, fill = 0,align="center")  
    draw_Himage.text((koordinaten_tagesforecast_x+155, koordinaten_tagesforecast_y+140), az.vorhersage_tag2_temperatur_max, font = font36, fill = 0,align="center")  
    

    #3. Tag
    draw_Himage.text((koordinaten_tagesforecast_x+340, koordinaten_tagesforecast_y+15), az.vorhersage_tag3_zeit, font = font28, fill = 0,align="center")
    draw_Himage.text((koordinaten_tagesforecast_x+375, koordinaten_tagesforecast_y+15), az.vorhersage_tag3_wind, font = sketchfont, fill = 0,align="center")    
    draw_Himage.text((koordinaten_tagesforecast_x+325, koordinaten_tagesforecast_y+45), az.vorhersage_tag3_wettersymbol, font = fontWeatherIcons60, fill = 0,align="center")  
    draw_Himage.text((koordinaten_tagesforecast_x+310, koordinaten_tagesforecast_y+110), az.vorhersage_tag3_temperatur_min, font = font36, fill = 0,align="center")  
    draw_Himage.text((koordinaten_tagesforecast_x+310, koordinaten_tagesforecast_y+140), az.vorhersage_tag3_temperatur_max, font = font36, fill = 0,align="center")  
    


#################### Block 4 #################################
    draw_Himage_Other.line((0,650,480,650),fill = 0, width=2)
    
    koordinaten_fusszeile_x=koordinaten_block1_x+40
    koordinaten_fusszeile_y=koordinaten_block1_y+670
    
    #Solar ertrag (war vorher forecast)
    koordinaten_solarforecast_x=koordinaten_fusszeile_x+30
    koordinaten_solarforecast_y=koordinaten_fusszeile_y
    draw_Himage.text((koordinaten_solarforecast_x-15, koordinaten_solarforecast_y-8), "Ertrag", font = font12, fill = 0)  
    draw_Himage.text((koordinaten_solarforecast_x-15, koordinaten_solarforecast_y), "<", font = peaxFont_small, fill = 0)  
    draw_Himage.text((koordinaten_solarforecast_x+10, koordinaten_solarforecast_y), az.solar_aktuell_ertrag, font = font28, fill = 0)  

    #Energieverbrauch
    koordinaten_solarforecast_x=koordinaten_fusszeile_x+30
    koordinaten_solarforecast_y=koordinaten_fusszeile_y+40
    draw_Himage.text((koordinaten_solarforecast_x-15, koordinaten_solarforecast_y-8), "Energieverbrauch", font = font12, fill = 0)  
    draw_Himage.text((koordinaten_solarforecast_x-10, koordinaten_solarforecast_y), "V", font = peaxFont_small, fill = 0)  
    draw_Himage.text((koordinaten_solarforecast_x+15, koordinaten_solarforecast_y), az.energie_heute, font = font28, fill = 0)  



    #Autarky
    koordinaten_autarky_x=koordinaten_fusszeile_x+30
    koordinaten_autarky_y=koordinaten_fusszeile_y
    draw_Himage.text((koordinaten_autarky_x+160, koordinaten_autarky_y-10), "Autarkie", font = font12, fill = 0)  
    draw_Himage.text((koordinaten_autarky_x+160, koordinaten_autarky_y), "c", font = sketchfont_small, fill = 0)  
    draw_Himage.text((koordinaten_autarky_x+180, koordinaten_autarky_y), az.autarky_tag, font = font28, fill = 0)  

    #Einspeisevergütung
    koordinaten_autarky_x=koordinaten_fusszeile_x+30
    koordinaten_autarky_y=koordinaten_fusszeile_y+40
    draw_Himage.text((koordinaten_autarky_x+160, koordinaten_autarky_y-10), "Einspeisung", font = font12, fill = 0)  
    draw_Himage.text((koordinaten_autarky_x+160, koordinaten_autarky_y), "9", font = sketchfont_small, fill = 0)  
    draw_Himage.text((koordinaten_autarky_x+180, koordinaten_autarky_y), az.einspeiseverguetung, font = font28, fill = 0)  
    


    #Update
    koordinaten_lastupdate_x=koordinaten_fusszeile_x+120
    koordinaten_lastupdate_y=koordinaten_fusszeile_y+70
    draw_Himage.text((koordinaten_lastupdate_x, koordinaten_lastupdate_y+25), az.last_update, font = font12, fill = 0)  
    
    #Pandabär
    draw_Himage.text((koordinaten_autarky_x+300, koordinaten_autarky_y-60), "3", font = funfont, fill = 0)  
    
    
    
    




    #draw_Himage.text((0, 220), "fge/o0", font = sketchfont, fill = 0)  
    #draw_Himage.text((0, 320), ";=s?<s>N/", font = sketchfont2, fill = 0)  
    
    #draw_Himage.text((20, 100), 'hello world', font = font28, fill = 0)
   # draw_Himage.text((480, 798), '480/798', font = font24, fill = 0)
    #draw_Himage_Other.text((20, 50), u'微雪电子', font = font18, fill = 0)
    #draw_Himage.text((120, 150), '1', font = fontWeatherIcons, fill = 0)
    #draw_Himage.text((120, 350), 'D', font = fontWeatherIcons, fill = 0)
    #draw_Himage_Other.text((160, 200), '1', font = fontWeatherIcons, fill = 0)
    
    # draw_Himage_Other.line((10, 90, 60, 140), fill = 0)
    # draw_Himage_Other.line((60, 90, 10, 140), fill = 0)
    # draw_Himage_Other.rectangle((10, 90, 60, 140), outline = 0)
    # draw_Himage_Other.line((95, 90, 95, 140), fill = 0)
    # draw_Himage.line((70, 115, 120, 115), fill = 0)
    # #draw_Himage.arc((70, 90, 120, 140), 0, 360, fill = 0)
    #draw_Himage.rectangle((10, 150, 60, 200), fill = 0)
    #draw_Himage.chord((70, 150, 120, 200), 0, 360, fill = 0)

    

    epd.display(epd.getbuffer(Limage), epd.getbuffer(Limage_Other))
    #time.sleep(2)

    logging.info("Clear...")
    #epd.init()
    #epd.Clear()

    logging.info("Goto Sleep...")
    epd.sleep()
    
except IOError as e:
    logging.info(e)
    
except KeyboardInterrupt:    
    logging.info("ctrl + c:")
    epd7in5b_V2.epdconfig.module_exit(cleanup=True)
    exit()

    