#!/usr/bin/python
# -*- coding:utf-8 -*-
import sys
import os
picdir = 'pic'
libdir = 'lib'
if os.path.exists(libdir):
    sys.path.append(libdir)

import logging
from lib.waveshare_epd import epd7in5b_V2
import time
from PIL import Image, ImageDraw, ImageFont, ImageEnhance
import traceback

from functions import clear_display

logging.basicConfig(level=logging.DEBUG)
#import pillow  # or any other image library

# Initialisieren Sie das Display und konfigurieren Sie es für rot
#epd = waveshare_epd.EPD()
epd = epd7in5b_V2.EPD()
epd.init()
epd.set_frame_mode(epd.FRAME_MODE_A)    # Setzen Sie den Frame-Modus auf A
epd.set_memory_mode(epd.MEMORY_MODE_DU2)   # Setzen Sie den Speichermodus auf DU2
epd.set_lut_mode(epd.LUT_MODE_RED)      # Stellen Sie den LUT-Modus auf rot
epd.set_data_start_transmission(2)      # Setzen Sie Data Start Transmission auf 2

# Erstellen Sie ein Bild mit rotem Text
image = pillow.Image.new('1', (128, 80))
draw = pillow.ImageDraw.Draw(image)
draw.text((10, 10), "Roter Text", fill=(255, 0, 0))

# Konvertieren Sie das Bild in das Format BMP
image = image.convert('RGB').save('red_text.bmp')

# Senden Sie das Bild an das Display
epd.display_frame(epd.get_frame(image))

# Freigeben von Ressourcen
epd.clear_frame()
epd.deep_sleep()